@REM BEGIN COPYRIGHT
@REM *************************************************************************
@REM Licensed Materials - Property of IBM 
@REM 5724-L01, 5655-N53, 5724-I82, 5655-R15
@REM (C) Copyright IBM Corporation 2004, 2006. All rights reserved. 
@REM US Government Users Restricted Rights - Use, duplication, or disclosure
@REM restricted by GSA ADP Schedule Contract with IBM Corp.
@REM *************************************************************************
@REM END COPYRIGHT

@echo off

set ACTION=HELP
if "%1" == "createDB" set ACTION=createDB
if "%1" == "createTable" set ACTION=createTable
if "%1" == "createJDBCProvider" set ACTION=createJDBCProvider
if "%1" == "createDataSource" set ACTION=createDataSource

if "%1" == "-?" set ACTION=HELP
if "%1" == "-help" set ACTION=HELP
if "%1" == "-h" set ACTION=HELP
if "%1" == "/?" set ACTION=HELP
if "%1" == "/help" set ACTION=HELP
if "%1" == "/h" set ACTION=HELP

call "%~dp0setupCmdLine.bat" %*

set TEMPLATE_PATH=%WAS_HOME%\profileTemplates\default.wbicore

set WS_CMT_LOG_HOME=%WAS_HOME%\logs\manageprofiles

rem ----------------------------------
rem ACTION=Help
rem ----------------------------------
if "%ACTION%"=="HELP" goto Usage



rem ----------------------------------
rem ACTION=createJDBCProvider
rem ----------------------------------
if "%ACTION%" == "createJDBCProvider" (
	set PRE_ACTION=createVariables.dbType createVariables.db2.universal createVariables.db2.zos

	rem startWsadminListener
	call %WAS_HOME%\bin\ws_ant -file %TEMPLATE_PATH%\actions\launchWsAdminListener.ant -DWAS_HOME=%WAS_HOME% -DWS_CMT_LOG_HOME=%WS_CMT_LOG_HOME% -DprofilePath=%profilePath% -DprofileName=%profileName% 
	
	call %WAS_HOME%\bin\ws_ant -file %WAS_HOME%\util\dbUtils\profileHelpers\commonDBUtility.ant %PRE_ACTION% %* -Dwas.install.root=%WAS_HOME% -DWS_CMT_LOG_HOME=%WS_CMT_LOG_HOME% -DWAS_HOME=%WAS_HOME% 
	
	rem stopWsadminListener
	call %WAS_HOME%\bin\ws_ant -file %TEMPLATE_PATH%\actions\stopWsAdminListener.ant -DprofilePath=%profilePath%
	
	goto :EOF
)

rem ----------------------------------
rem ACTION=createDataSource
rem ----------------------------------
if "%ACTION%" == "createDataSource" (
	rem startWsadminListener
	call %WAS_HOME%\bin\ws_ant -file %TEMPLATE_PATH%\actions\launchWsAdminListener.ant -DWAS_HOME=%WAS_HOME% -DWS_CMT_LOG_HOME=%WS_CMT_LOG_HOME% -DprofilePath=%profilePath% -DprofileName=%profileName% 
	
	call %WAS_HOME%\bin\ws_ant -file %WAS_HOME%\util\dbUtils\profileHelpers\commonDBUtility.ant %* -Dwas.install.root=%WAS_HOME% -DWS_CMT_LOG_HOME=%WS_CMT_LOG_HOME% -DWAS_HOME=%WAS_HOME% 
	
	rem stopWsadminListener
	call %WAS_HOME%\bin\ws_ant -file %TEMPLATE_PATH%\actions\stopWsAdminListener.ant -DprofilePath=%profilePath%
	
	goto :EOF
)

rem ----------------------------------
rem ACTION=createTable
rem ----------------------------------
if "%ACTION%" == "createTable" (
	call %WAS_HOME%\bin\ws_ant -file %WAS_HOME%\util\dbUtils\profileHelpers\commonDBUtility.ant %* -Dwas.install.root=%WAS_HOME% -DWS_CMT_LOG_HOME=%WS_CMT_LOG_HOME% -DWAS_HOME=%WAS_HOME% 
	goto :EOF
)

rem ----------------------------------
rem ACTION=createDB
rem ----------------------------------
if "%ACTION%" == "createDB" (
	call %WAS_HOME%\bin\ws_ant -file %WAS_HOME%\util\dbUtils\profileHelpers\commonDBUtility.ant %* -Dwas.install.root=%WAS_HOME% -DWS_CMT_LOG_HOME=%WS_CMT_LOG_HOME% -DWAS_HOME=%WAS_HOME% 
	goto :EOF
)


:Usage
echo Usage: DBUtility action [args...]
echo. 
echo Where action includes:
echo     createDB            create a new database
echo     createTable         create tables with given sql script on given Database
echo     createJDBCProvider  create new JDBCProvider
echo     createDataSource    create new DataSource for given JDBCProvider
echo.
echo Where args include:
echo    "createDB" is the action, following args are needed:
echo        -DprofilePath=^<profilePath^>   The path of profile
echo        -DprofileName=^<profileName^>   The name of profile
echo        -DdbCreateNew=^<boolean^>       The Flag is to be true to create DB
echo        -DdbType=^<dbType^>             The database type 
echo        -DdbName=^<dbName^>             The database name or alias name
echo        -DdbLocation=^<dbLocation^>     The path of database install root 
echo        -DdbUserId=^<dbUserId^>         The user id to access database
echo        -DdbPassword=^<dbPassword^>     The password to access the database
echo        -DdbInstance=^<dbInstance^>     The database instance name --only required for Informix
echo        -DdbSchemaName=^<dbSchemaName^> The schema name
echo        -DdbServerName=^<dbServerName^> The database server name --only required for Sybase
echo.
echo    "createTable" is the action, following args are needed:
echo        -DprofilePath=^<profilePath^>   The path of profile
echo        -DdbType=^<dbType^>             The database type
echo        -DprofileName=^<profileName^>   The name of profile
echo        -DdbDelayConfig=^<boolean^>     The Flag is to be false to create Table
echo        -DdbName=^<dbName^>             The database name or alias name
echo        -DsqlScriptPath.default=^<defautlSqlPath^>
echo                                        The default sql script for creating table
echo                                        DBUtility will attempt to find sql script for each database type
echo                                        in this naming convention ^<defautlSqlPath^>_^<dbType^>.sql.
echo                                        DBUtility will run ^<defautlSqlPath^>, 
echo                                        if ^<defautlSqlPath^>_^<dbType^>.sql does not exist.
echo        -DsqlScriptName.default=^<defautlSqlScriptName^>
echo 					              The default sql script name for creating table
echo                                        DBUtility will attempt to form a sql script path for each database type
echo                                        in this naming convention ^<defautlSqlScriptName^>_^<dbType^>.sql.
echo                                        DBUtility will run ^<defautlSqlScriptName^>, 
echo                                        if ^<defautlSqlScriptName^>_^<dbType^>.sql does not exist.
echo        -DdbHostName=^<dbHostName^>     The host name or IP address for database server
echo        -DdbServerPort=^<dbServerPort^> The JDBC port number for database server
echo        -DdbJDBCClasspath=^<dbJDBCClasspath^>    
echo                                        The directory path which contains JDBC driver files
echo        -DdbUserId=^<dbUserId^>         The user id to access database
echo        -DdbPassword=^<dbPassword^>     The password to access the database
echo        -DdbInstance=^<dbInstance^>     The database instance name --only required for Informix
echo        -DdbSchemaName=^<dbSchemaName^> The schema name
echo        -DdbConnectionLocation=^<dbConnectionLocation^>
echo                                        The database connection location --only required for zOS
echo        -DdbStorageGroup=^<dbStorageGroup^>
echo                                        The database storage group --only required for zOS
echo        -DdbJDBCProperties=^<dbJDBCProperties^>
echo                                        The directory containing DB2JccConfiguration.properties --only required for zOS
echo.
echo    "createJDBCProvider" is the action, following args are needed:
echo        -DprofilePath=^<profilePath^>   The path of profile
echo        -DdbType=^<dbType^>             The database type
echo        -DprofileName=^<profileName^>   The name of profile
echo        -DdbJDBCClasspath=^<dbJDBCClasspath^>    
echo                                        The directory path which contains JDBC driver files
echo        -DscopeLevel=^<scopeLevel^>     The scope level, valid values are "node", "cell"
echo        -DcellName=^<cellName^>         The cell name
echo        -DnodeName=^<nodeName^>         The node name
echo.
echo    "createDataSource" is the action, following args are needed:
echo        -DjndiName=^<jndiName^>         The dataSource jndiName
echo        -DprofilePath=^<profilePath^>   The path of profile 
echo        -DprofileName=^<profileName^>   The name of profile
echo        -DdbType=^<dbType^>             The database type
echo        -DdbName=^<dbName^>             The database name or alias name
echo        -DdbHostName=^<dbHostName^>     The host name or IP address for database server
echo        -DdbServerPort=^<dbServerPort^> The JDBC port number for database server
echo        -DdbUserId=^<dbUserId^>         The user id to access database
echo        -DdbPassword=^<dbPassword^>     The password to access the database
echo        -DdbInstance=^<dbInstance^>     The database instance name --only required for Informix
echo        -DdbSchemaName=^<dbSchemaName^> The schema name
echo        -DdbConnectionLocation=^<dbConnectionLocation^>
echo                                        The database connection location --only required for zOS
echo        -DdbStorageGroup=^<dbStorageGroup^>     
echo                                        The database storage group --only required for zOS
echo        -DdbJDBCClasspath=^<dbJDBCClasspath^>    
echo                                        The directory path which contains JDBC driver files
echo        -DscopeLevel=^<scopeLevel^>     The scope level, valid values are "node", "cell"
echo        -DcellName=^<cellName^>         The cell name
echo        -DnodeName=^<nodeName^>         The node name
goto :EOF
